#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <X11/extensions/xf86dga.h>
#include <X11/extensions/xf86vmode.h>
#include "misc.c"


int vm_count,i;
XF86VidModeModeInfo **vm_modelines;
Display *dpy;
int ok=0;


void switch_X11_mode () {
    if (show == 0) {
	if (xswitch_to > vm_count) {
	    fprintf(stderr,"[xvidmode] error in commandline -m%d: bad modeline number\n",xswitch_to);
	    exit(1);
	}
	printf("switching to modeline number: %d (%dx%d)\n",xswitch_to,vm_modelines[xswitch_to]->hdisplay,vm_modelines[xswitch_to]->vdisplay);
    }
    XF86VidModeSwitchToMode(dpy,XDefaultScreen(dpy),vm_modelines[xswitch_to]);
    XFlush(dpy);
}


void ywitch_X11_mode () {
    for (i=0; i<vm_count; i++) {
	if (xwidth == vm_modelines[i]->hdisplay) {
	    if (xheight == vm_modelines[i]->vdisplay) {
	        if (show == 0) {
		    printf("switching to mode: %dx%d\n",xwidth,xheight);
		}
		XF86VidModeSwitchToMode(dpy,XDefaultScreen(dpy),vm_modelines[i]);
		XFlush(dpy);
		ok = 1;
	    }
	}
    }
}







int main(int argc,char **argv) 
{
  dpy=XOpenDisplay("");
  if (dpy==NULL)   {
    fprintf(stderr,"[xvidmode] error: can't open X11 display\n");
    exit(1);
  }

  XF86VidModeGetAllModeLines(dpy,XDefaultScreen(dpy),&vm_count,&vm_modelines);


  do_options(argc, argv);

  if (show_number == 1) {
      printf("%d",vm_count-1);
      return 0;
  }  

  if (list == 1) {
      printf("%dx%d",vm_modelines[list_nr]->hdisplay,vm_modelines[list_nr]->vdisplay);
      return 0;
  }  
      
  
  if (xswitch == 1) {
      switch_X11_mode();
      return 0;
  }  

  if (yswitch == 1) {
      ywitch_X11_mode();
      if (ok == 0) {
          fprintf(stderr,"[xvidmode] error: unknown mode: %s\n",yswitch_to);
	  exit(1);
      }
      return 0;
  }  

  if (show == 0) {  
    printf("\n* xvidmode 1.0 by kLoGraFX / Adam Kopacz\n");
    printf("* http://www.idnet.de/~AdamK  (Adam.K@idnet.de)\n\n");
    printf("%d modelines found:\n\n",vm_count);
				   
        for (i = 0; i < vm_count; i++) {
	    if (i == 0)
		{
		    printf("\t%d: %dx%d (current)\n",i,vm_modelines[i]->hdisplay,vm_modelines[i]->vdisplay);
		}else{
		    printf("\t%d: %dx%d\n",i,vm_modelines[i]->hdisplay,vm_modelines[i]->vdisplay);
		}
        }
	printf("\n");
  }else{
        for (i = 0; i < vm_count; i++) {
	    printf("%dx%d\n",vm_modelines[i]->hdisplay,vm_modelines[i]->vdisplay);
        }
  }
return 0;
}


